--yMerchant,自动修理
local yMerchant = CreateFrame('Frame')
yMerchant:SetScript('OnEvent', function(self, event, ...) if self[event] then return self[event](self, ...) end end)
yMerchant:RegisterEvent('MERCHANT_SHOW')
yMerchant:RegisterEvent('START_LOOT_ROLL')

local AutoSellJunk = true
local AutoRepair = true
local UseGuildBank = true
local AutoGreed = true
local _G = _G

local CustomSellList = {
	--[itemID] = true,
	--[17058] = true, -- Fish Oil
}

function yMerchant:MERCHANT_SHOW()
	if AutoSellJunk then
		for bag = 0, 4 do
			for slot = 0, GetContainerNumSlots(bag) do
				local link = GetContainerItemLink(bag, slot)
				if link then
					local id = tonumber(link:match'item:(%d+):')
					if select(3, GetItemInfo(id)) == 0 or CustomSellList[id] then
						ShowMerchantSellCursor(1)
						UseContainerItem(bag, slot)
					end
				end
			end
		end
	end
	if AutoRepair and CanMerchantRepair() then
		local cost, canRepair = GetRepairAllCost()
		if canRepair then
			local str = GetCoinTextureString(cost, 10)			-- GetMoneyString
			local limit = GetGuildBankWithdrawMoney()
			local money = GetGuildBankMoney()
			if UseGuildBank and IsInGuild() and CanGuildBankRepair() and ((limit == -1 and money >= cost) or min(limit, money) >= cost) then
				RepairAllItems(1)
				str = '公款修理：' .. str
			elseif GetMoney() >= cost then
				RepairAllItems()
				str = '自费修理：' .. str
			else
				DEFAULT_CHAT_FRAME:AddMessage('修理需要：' .. str)
				return
			end
			PlaySound('ITEM_REPAIR')
			DEFAULT_CHAT_FRAME:AddMessage(str)
		end
	end
end

function yMerchant:START_LOOT_ROLL(id)
	if not AutoGreed or not id then return end
	local _, _, _, quality, bop, _, _, canDE = GetLootRollItemInfo(id)
	if quality == 2 and not bop then RollOnLoot(id, canDE and 3 or 2) end
end

-- Focuser,shift+鼠标左键
local modifier = "shift" -- shift, alt or ctrl
local mouseButton = "1" -- 1 = left, 2 = right, 3 = middle, 4 and 5 = thumb buttons if there are any

local function SetFocusHotkey(frame)
	frame:SetAttribute(modifier.."-type"..mouseButton, "focus")
end

local function CreateFrame_Hook(type, name, parent, template)
	if name and template == "SecureUnitButtonTemplate" then
		SetFocusHotkey(_G[name])
	end
end

hooksecurefunc("CreateFrame", CreateFrame_Hook)

local fr = CreateFrame("CheckButton", "FocuserButton", UIParent, "SecureActionButtonTemplate")
fr:SetAttribute("type1", "macro")
fr:SetAttribute("macrotext", "/focus mouseover")
SetOverrideBindingClick(FocuserButton, true, modifier.."-BUTTON"..mouseButton, "FocuserButton")

local duf = {
	PetFrame,
	PartyMemberFrame1,
	PartyMemberFrame2,
	PartyMemberFrame3,
	PartyMemberFrame4,
	PartyMemberFrame1PetFrame,
	PartyMemberFrame2PetFrame,
	PartyMemberFrame3PetFrame,
	PartyMemberFrame4PetFrame,
	PartyMemberFrame1TargetFrame,
	PartyMemberFrame2TargetFrame,
	PartyMemberFrame3TargetFrame,
	PartyMemberFrame4TargetFrame,
	TargetFrame,
	TargetFrameToT,
	TargetFrameToTTargetFrame,
}

for i, frame in pairs(duf) do
	SetFocusHotkey(frame)
end
  
--超出距离技能栏变红
hooksecurefunc("ActionButton_OnUpdate", function(self, elapsed)
   if ( self.rangeTimer == TOOLTIP_UPDATE_TIME and self.action) then
      local range = false
      if ( IsActionInRange(self.action) == false ) then
         getglobal(self:GetName().."Icon"):SetVertexColor(1, 0, 0)
         getglobal(self:GetName().."NormalTexture"):SetVertexColor(1, 0, 0)
         range = true
      end;
      if ( self.range ~= range and range == false ) then
         ActionButton_UpdateUsable(self)
      end;
      self.range = range
   end
end)

--重载命令
SlashCmdList["RELOADUI"] = function() ReloadUI() end
SLASH_RELOADUI1 = "/rl"

--[[脱战回收内存
local th = CreateFrame("Frame")
   th:RegisterEvent("PLAYER_REGEN_ENABLED")
   th:SetScript("OnEvent", function() _G.collectgarbage("collect") end)
   th:SetScript("OnEvent", eventHandler)
   ]]