--[地图上标记队友名称并显示战斗或者死亡]
local function colored(class)
   local colorRGB = RAID_CLASS_COLORS[class] or NORMAL_FONT_COLOR
   return format("|CFF%2x%2x%2x", colorRGB.r*255, colorRGB.g*255, colorRGB.b*255)
end

local sub, GetRaidRosterInfo = string.sub, GetRaidRosterInfo
hooksecurefunc("WorldMapUnit_Update", function(self)
   if not self.group then
      self.group = self:CreateFontString(nil, "OVERLAY")
      self.group:SetFont(STANDARD_TEXT_FONT, 14, "THINOUTLINE")
      self.group:SetPoint("LEFT", self, "RIGHT")
   end
   self.group:SetText("")
   if self.unit then
      if string.find(self.unit, "raid") then
         local longName, _, _, _, _, class = GetRaidRosterInfo(sub(self.unit,5))
         if longName then
            local _, _, shortName, server = string.find(longName, "([^%-]+)%-(.+)")
            if not server then
               shortName = longName
            end
            self.group:SetText(colored(class)..sub(shortName,1,6).."|r")
         end
      end
      if UnitAffectingCombat(self.unit) then
         self.icon:SetVertexColor(1, 0, 0) -- 戰鬥中顏色0.8
         self:SetAlpha(1)
      elseif UnitIsDeadOrGhost(self.unit) then
         self.icon:SetVertexColor(0, 0, 0) -- 死亡顏色
         self:SetAlpha(.7)
      else
         self:SetAlpha(.7)
      end
   end
end)